#!/usr/bin/env python2.5
# coding: utf-8
from PyQt4.QtGui import (
    QApplication, QWizard, QWizardPage, QLabel, QButtonGroup, QRadioButton,
    QFormLayout, QPixmap, QIcon, QPushButton, QVBoxLayout, QGroupBox,
    QCheckBox, QMessageBox, QTableWidget, QSizePolicy, QHBoxLayout
)
from PyQt4.QtCore import SIGNAL, Qt, QTimer, QSize
from pixmaps import logo_xpm
from sys import argv


#Credits:
#plan de Saigon: http://upload.wikimedia.org/wikipedia/commons/2/2c/Plan_de_la_Villa_1795_by_Le_Brun.png

WINDOW_TITLE = "PyQt4: un toolkit multiplateforme, graphique et plus"
class PresentationPage(QWizardPage):
    def __init__(self, parent=None):
        QWizardPage.__init__(self, parent)
        self.form = QFormLayout(self)

PAGE_IDS = INTRO = 0

class Intro(PresentationPage):
    def __init__(self, parent=None):
        PresentationPage.__init__(self, parent)
        self.setTitle("Plan")
#        self.setSubTitle("Introduction")

        self.setPixmap(QWizard.WatermarkPixmap,
            QPixmap("Plan_de_la_Villa_1795_by_Le_Brun-border.png")
        )
        self.setPixmap(QWizard.BackgroundPixmap,
            QPixmap("Plan_de_la_Villa_1795_by_Le_Brun-shade.png")
        )

        plan = QLabel()
        plan.setText(
                "<ul>"
                    "<li>" u"Objectifs de la bibliothèque" "</li>"
                    "<li>" u"Composants" "</li>"
                    "<li>" u"Apparence" "</li>"
                "</ul>"
                "<br/>"
                "<br/>"
                "<br/>"
                "<br/>"
                "<br/>"
                "<br/>"
                "<br/>"
                "<br/>"
                "<i>Feth AREZKI</i>"
                )

        self.form.addRow(plan)

class TextPage(PresentationPage):
    def __init__(self, title, subtitle, text, parent=None):
        PresentationPage.__init__(self, parent)
        self.setTitle(title)
        self.setSubTitle(subtitle)
        label = QLabel()
        label.setText(text)
        self.form.addRow(label)

class WhatsQt(QWizardPage):
    def __init__(self, parent=None):
        QWizardPage.__init__(self, parent)
        self.setTitle('Objectifs de PyQt')
        self.setSubTitle("Conception rapide, "
            "efficace d'applications parfaites")

        baby = QPixmap("baby2.0.png")
        self.setPixmap(QWizard.WatermarkPixmap,
            baby
        )
        self.setPixmap(QWizard.BackgroundPixmap,
            baby
        )

        text = u"""\
<div style=" font-size:16pt; ">
        <ul>
            <li> Découpage du workflow selon les corps de métier
                <ul>
                    <li> ergonomie </li>
                    <li> logique de l'application </li>
                    <li> traduction </li>
                </ul>
            </li>
            <li>Faciliter la vie des différents professionnels
                <ul>
                    <li> designer </li>
                    <li> super API </li>
                    <li> linguist </li>
                </ul>
            </li>
            <li> Souplesse et qualité logicielle grace à<br/>
            l'héritage, la factorisation et Python </li>
        </ul>
</div>"""
        layout = QHBoxLayout()
        label_text = QLabel()
        label_text.setText(text)
        layout.addWidget(label_text)
        self.setLayout(layout)

class WhatsQtBis(PresentationPage):
    def __init__(self, parent=None):
        PresentationPage.__init__(self, parent)
        self.setTitle('Objectifs de PyQt')
        self.setSubTitle("Une interface de programmation uniforme "
            "quelle que soit la plateforme",)

        self.form.addRow(QLabel("<h2>Modules de PyQt</h2>"))
        self.form.addRow(self.genTable())

    def genTable(self, parent=None):
        modules = \
        """\
QtCore  Core non-GUI classes used by other modules
QtGui  Graphical user interface components
QtHelp  Classes for online help
QtNetwork  Classes for network programming
QtOpenGL  OpenGL support classes
QtScript  Classes for evaluating Qt Scripts
QtSql  Classes for database integration using SQL
QtSvg  Classes for displaying the contents of SVG files
QtTest  Functions for unit testing PyQt applications
QtWebKit  Classes for rendering and editing HTML
QtXml  Classes for handling XML
QtXmlPatterns  An XQuery and XPath engine for XML and custom data models
phonon  Multimedia framework classes
QtAssistant  Support for online help
QtDesigner  Classes for extending Qt Designer
QAxContainer  Classes for accessing ActiveX controls"""

        table = QTableWidget(len(modules.splitlines()), 2, parent)
        table.setHorizontalHeaderLabels(["Module", "description"])
        for index, line in enumerate(modules.splitlines()):
            module_name, description = line.split("  ")
            name_label = QLabel()
            name_label.setText(module_name)
            description = QLabel(description)
            table.setCellWidget(index, 0, name_label)
            table.setCellWidget(index, 1, description)
        table.setSizePolicy(QSizePolicy.Preferred, QSizePolicy.Expanding)
        table.resizeColumnsToContents()
        table.resizeColumnToContents(1)
        wiz_pix = QPixmap("znp_with_baby_tiger.jpg")
        self.setPixmap(QWizard.WatermarkPixmap,
            wiz_pix
        )
        self.setPixmap(QWizard.BackgroundPixmap,
            wiz_pix
        )
        return table

class WhatsQt2(PresentationPage):
    def __init__(self, style=QWizard.ModernStyle, parent=None):
        PresentationPage.__init__(self, parent)
        self.setTitle("Respecter le look and feel de la plateforme")
        self.setSubTitle("Styles disponibles")

        styles = \
            win_classic, win_modern, mac, win_aero = \
            tuple(QRadioButton(text) for text in(
                "Classic Windows", "Modern Windows",
                "Mac (Cocoa)", "Windows Aero")
            )

        desktop_groupbox = QGroupBox()
        desktop_groupbox.setCheckable(True)
        desktop_groupbox.setTitle("Desktop")
        desktop_groupbox.setAlignment(Qt.AlignLeft)
        box = QVBoxLayout(desktop_groupbox)
        self.group = QButtonGroup()
        for index, button in enumerate(styles):
            self.group.addButton(button, index)
            box.addWidget(button)
            self.connect(button, SIGNAL('clicked()'), self.go_style)
        self.group.button(style).setChecked(Qt.Checked)

        self.setTitle('Multiplateforme')
        self.setSubTitle('Changeons les styles !')
        self.form.addRow(QLabel("<h2>Multiplateforme</h2>"))
        self.form.addRow(desktop_groupbox)

        self.embedded = QCheckBox(u"Embarqué (via Qtopia")
        self.embedded.setChecked(Qt.Unchecked)
        self.connect(
            self.embedded,
            SIGNAL('stateChanged(int)'),
            self.confirmEmbed
        )
        self.form.addRow(self.embedded)

        self.form.addRow(QLabel(u"<h2>Multilingue</h2>"))
        self.form.addRow(QLabel(u"<h3>Traduction avec Linguist</h3>"))
        self.form.addRow(QLabel(u"<h3>Mise en page adaptée au sens d'écriture</h3>"))

    def confirmEmbed(self, state):
        if state != Qt.Checked:
            return

        msg = QMessageBox.critical(self, u"Avertissement",
            u"Vous devez être root sur cet univers "
            u"pour transformer cet ordinateur surpuissant "
            u"en système embarqué.")
        self.embedded.setChecked(Qt.Unchecked)

    def go_style(self):
        self.emit(SIGNAL('go style'), self.group.checkedId())

class ClickableLabel(QLabel):
    def mousePressEvent(self, event):
        self.hide()
        self.emit(SIGNAL('ok'))

    keyPressEvent = mousePressEvent

class Exemples(QWizardPage):
    def __init__(self, parent=None):
        QWizardPage.__init__(self, parent)
        self.setTitle("Enfin la fin")
        self.setSubTitle(u"Questions, crédits")
        box = QVBoxLayout(self)
        self.examples = []
        examples = """\
kde.png
vlc.png
adobe_photoalbum_shot.jpg
""".splitlines()
        for example in (examples):
            pixmap = QPixmap(example)
            label = ClickableLabel()
            label.setPixmap(pixmap)
            label.setAlignment(Qt.AlignCenter)
            self.examples.append(label)

        #first will be clicked last
        self.connect(self.examples[0], SIGNAL('ok'), self.reshow)

        empty = QLabel()

        end_label = QLabel()
        end_label.setPixmap(QPixmap("doc.png"))
        end_label.setFixedSize(QSize(360, 240))
        end_label.setSizePolicy(QSizePolicy.Minimum, QSizePolicy.Minimum)

        merci = QLabel()
        merci.setText(u"Merci…")
        urls = QLabel("<tt>http://doc.trolltech.com/ - http://www.riverbankcomputing.com</tt>")
        book = QLabel("<i>Rapid Gui Programmming with Python and Qt</i>"
        " (M. Summerfield)")

        credits = QLabel()
        credits.setText(
            u"<h2>Crédits</h2>"
            "<ul>"
            "<li>"
            "<tt>znp with white baby tiger: "
            "http://www.flickr.com/photos/yapex/220866860/</tt>"
            "</li>"
            "<li>"
            "<tt>Very happy baby: "
            "http://www.flickr.com/photos/yogi/54489046/</tt>"
            "</li>"
            "<li>"
            "<tt>plan de Saigon: "
            "http://upload.wikimedia.org/wikipedia/commons/"
            "2/2c/Plan_de_la_Villa_1795_by_Le_Brun.png</tt>"
            "</li>"
            "<li>"
            "<tt>captures (non libres): "
            "Site qt software</tt>"
            "</li>"
            "</ul>"
)
        box.addWidget(merci)
        box.addWidget(end_label)
        box.addWidget(urls)
        box.addWidget(book)
        box.addWidget(credits)
        box.addStretch()

    def initializePage(self):
        self.emit(SIGNAL('hide'))
        for example in self.examples:
            example.showFullScreen()
            example.raise_()

    def reshow(self):
        self.emit(SIGNAL('show'))
        for example in self.examples:
            example.close()

class IntroWizard(QWizard):
    def __init__(self, style=1, page_id=None, restart=False, parent=None):
        QWizard.__init__(self, parent)
        self.page_id = page_id
        print "style", style
        self.setWizardStyle(style)

        self.setWindowTitle(WINDOW_TITLE)

        self.setOption(QWizard.NoBackButtonOnStartPage)
        self.setOption(QWizard.NoCancelButton)
        self.setPixmap(QWizard.LogoPixmap, QPixmap("logo.png"))

        intro = Intro()
        self.setPage(0, intro)
        self.setPage(1, WhatsQt())
        self.setPage(2, WhatsQtBis())
        whats_qt2 = WhatsQt2(style=style)
        self.setPage(3, whats_qt2)
        examples = Exemples()
        self.connect(examples, SIGNAL('show'), self.show)
        self.connect(examples, SIGNAL('hide'), self.hide)
        self.setPage(4, examples)

        self.connect(whats_qt2, SIGNAL('go style'), self.go_style)

        if page_id is not None:
            #self.setStartId(page_id)
            pass

    def go_style(self, style):
        wiz = IntroWizard(style=style, page_id=self.currentId(), restart=True)
        self.hide()
        #Very bad practice, we end up piling up several wizards
        wiz.exec_()


if __name__ == "__main__":
    app = QApplication(argv)
    if len(argv) > 1:
        style = int(argv[1])
        wiz = IntroWizard(style=style)
    else:
        wiz = IntroWizard()
    wiz.show()
    app.exec_()
